Index: apache-tomcat-9.0.33-src/java/org/apache/tomcat/util/buf/C2BConverter.java
===================================================================
--- apache-tomcat-9.0.33-src.orig/java/org/apache/tomcat/util/buf/C2BConverter.java
+++ apache-tomcat-9.0.33-src/java/org/apache/tomcat/util/buf/C2BConverter.java
@@ -17,6 +17,7 @@
 package org.apache.tomcat.util.buf;
 
 import java.io.IOException;
+import java.nio.Buffer;
 import java.nio.ByteBuffer;
 import java.nio.CharBuffer;
 import java.nio.charset.Charset;
@@ -51,7 +52,7 @@ public final class C2BConverter {
      */
     public void recycle() {
         encoder.reset();
-        leftovers.position(0);
+        ((Buffer)leftovers).position(0);
     }
 
     public boolean isUndeflow() {
@@ -71,16 +72,16 @@ public final class C2BConverter {
             bb = ByteBuffer.wrap(bc.getBuffer(), bc.getEnd(), bc.getBuffer().length - bc.getEnd());
         } else {
             // Initialize the byte buffer
-            bb.limit(bc.getBuffer().length);
-            bb.position(bc.getEnd());
+            ((Buffer)bb).limit(bc.getBuffer().length);
+            ((Buffer)bb).position(bc.getEnd());
         }
         if ((cb == null) || (cb.array() != cc.getBuffer())) {
             // Create a new char buffer if anything changed
             cb = CharBuffer.wrap(cc.getBuffer(), cc.getStart(), cc.getLength());
         } else {
             // Initialize the char buffer
-            cb.limit(cc.getEnd());
-            cb.position(cc.getStart());
+            ((Buffer)cb).limit(cc.getEnd());
+            ((Buffer)cb).position(cc.getStart());
         }
         CoderResult result = null;
         // Parse leftover if any are present
@@ -89,16 +90,16 @@ public final class C2BConverter {
             // Loop until one char is encoded or there is a encoder error
             do {
                 leftovers.put((char) cc.subtract());
-                leftovers.flip();
+                ((Buffer)leftovers).flip();
                 result = encoder.encode(leftovers, bb, false);
-                leftovers.position(leftovers.limit());
-                leftovers.limit(leftovers.array().length);
+                ((Buffer)leftovers).position(leftovers.limit());
+                ((Buffer)leftovers).limit(leftovers.array().length);
             } while (result.isUnderflow() && (bb.position() == pos));
             if (result.isError() || result.isMalformed()) {
                 result.throwException();
             }
-            cb.position(cc.getStart());
-            leftovers.position(0);
+            ((Buffer)cb).position(cc.getStart());
+            ((Buffer)leftovers).position(0);
         }
         // Do the decoding and get the results into the byte chunk and the char
         // chunk
@@ -115,8 +116,8 @@ public final class C2BConverter {
             cc.setOffset(cb.position());
             // Put leftovers in the leftovers char buffer
             if (cc.getLength() > 0) {
-                leftovers.limit(leftovers.array().length);
-                leftovers.position(cc.getLength());
+                ((Buffer)leftovers).limit(leftovers.array().length);
+                ((Buffer)leftovers).position(cc.getLength());
                 cc.subtract(leftovers.array(), 0, cc.getLength());
             }
         }
@@ -135,16 +136,16 @@ public final class C2BConverter {
             bb = ByteBuffer.wrap(bc.array(), bc.limit(), bc.capacity() - bc.limit());
         } else {
             // Initialize the byte buffer
-            bb.limit(bc.capacity());
-            bb.position(bc.limit());
+            ((Buffer)bb).limit(bc.capacity());
+            ((Buffer)bb).position(bc.limit());
         }
         if ((cb == null) || (cb.array() != cc.array())) {
             // Create a new char buffer if anything changed
             cb = CharBuffer.wrap(cc.array(), cc.arrayOffset() + cc.position(), cc.remaining());
         } else {
             // Initialize the char buffer
-            cb.limit(cc.limit());
-            cb.position(cc.position());
+            ((Buffer)cb).limit(cc.limit());
+            ((Buffer)cb).position(cc.position());
         }
         CoderResult result = null;
         // Parse leftover if any are present
@@ -153,16 +154,16 @@ public final class C2BConverter {
             // Loop until one char is encoded or there is a encoder error
             do {
                 leftovers.put(cc.get());
-                leftovers.flip();
+                ((Buffer)leftovers).flip();
                 result = encoder.encode(leftovers, bb, false);
-                leftovers.position(leftovers.limit());
-                leftovers.limit(leftovers.array().length);
+                ((Buffer)leftovers).position(leftovers.limit());
+                ((Buffer)leftovers).limit(leftovers.array().length);
             } while (result.isUnderflow() && (bb.position() == pos));
             if (result.isError() || result.isMalformed()) {
                 result.throwException();
             }
-            cb.position(cc.position());
-            leftovers.position(0);
+            ((Buffer)cb).position(cc.position());
+            ((Buffer)leftovers).position(0);
         }
         // Do the decoding and get the results into the byte chunk and the char
         // chunk
@@ -171,16 +172,16 @@ public final class C2BConverter {
             result.throwException();
         } else if (result.isOverflow()) {
             // Propagate current positions to the byte chunk and char chunk
-            bc.limit(bb.position());
-            cc.position(cb.position());
+            ((Buffer)bc).limit(bb.position());
+            ((Buffer)cc).position(cb.position());
         } else if (result.isUnderflow()) {
             // Propagate current positions to the byte chunk and char chunk
-            bc.limit(bb.position());
-            cc.position(cb.position());
+            ((Buffer)bc).limit(bb.position());
+            ((Buffer)cc).position(cb.position());
             // Put leftovers in the leftovers char buffer
             if (cc.remaining() > 0) {
-                leftovers.limit(leftovers.array().length);
-                leftovers.position(cc.remaining());
+                ((Buffer)leftovers).limit(leftovers.array().length);
+                ((Buffer)leftovers).position(cc.remaining());
                 cc.get(leftovers.array(), 0, cc.remaining());
             }
         }
Index: apache-tomcat-9.0.33-src/java/org/apache/tomcat/util/buf/Utf8Decoder.java
===================================================================
--- apache-tomcat-9.0.33-src.orig/java/org/apache/tomcat/util/buf/Utf8Decoder.java
+++ apache-tomcat-9.0.33-src/java/org/apache/tomcat/util/buf/Utf8Decoder.java
@@ -16,6 +16,7 @@
  */
 package org.apache.tomcat.util.buf;
 
+import java.nio.Buffer;
 import java.nio.ByteBuffer;
 import java.nio.CharBuffer;
 import java.nio.charset.CharsetDecoder;
@@ -140,7 +141,7 @@ public class Utf8Decoder extends Charset
             }
             return CoderResult.UNDERFLOW;
         } finally {
-            in.position(pos);
+            ((Buffer)in).position(pos);
         }
     }
 
@@ -163,8 +164,8 @@ public class Utf8Decoder extends Charset
                 // If first byte is invalid, tail will be set to -1
                 int tail = remainingBytes[jchar];
                 if (tail == -1) {
-                    in.position(inIndex - in.arrayOffset());
-                    out.position(outIndex - out.arrayOffset());
+                    ((Buffer)in).position(inIndex - in.arrayOffset());
+                    ((Buffer)out).position(outIndex - out.arrayOffset());
                     return CoderResult.malformedForLength(1);
                 }
                 // Additional checks to detect invalid sequences ASAP
@@ -175,72 +176,72 @@ public class Utf8Decoder extends Charset
                     // First byte C2..DF, second byte 80..BF
                     if (jchar > 0x41 && jchar < 0x60 &&
                             (bArr[inIndex + 1] & 0xC0) != 0x80) {
-                        in.position(inIndex - in.arrayOffset());
-                        out.position(outIndex - out.arrayOffset());
+                        ((Buffer)in).position(inIndex - in.arrayOffset());
+                        ((Buffer)out).position(outIndex - out.arrayOffset());
                         return CoderResult.malformedForLength(1);
                     }
                     // First byte E0, second byte A0..BF
                     if (jchar == 0x60 && (bArr[inIndex + 1] & 0xE0) != 0xA0) {
-                        in.position(inIndex - in.arrayOffset());
-                        out.position(outIndex - out.arrayOffset());
+                        ((Buffer)in).position(inIndex - in.arrayOffset());
+                        ((Buffer)out).position(outIndex - out.arrayOffset());
                         return CoderResult.malformedForLength(1);
                     }
                     // First byte E1..EC, second byte 80..BF
                     if (jchar > 0x60 && jchar < 0x6D &&
                             (bArr[inIndex + 1] & 0xC0) != 0x80) {
-                        in.position(inIndex - in.arrayOffset());
-                        out.position(outIndex - out.arrayOffset());
+                        ((Buffer)in).position(inIndex - in.arrayOffset());
+                        ((Buffer)out).position(outIndex - out.arrayOffset());
                         return CoderResult.malformedForLength(1);
                     }
                     // First byte ED, second byte 80..9F
                     if (jchar == 0x6D && (bArr[inIndex + 1] & 0xE0) != 0x80) {
-                        in.position(inIndex - in.arrayOffset());
-                        out.position(outIndex - out.arrayOffset());
+                        ((Buffer)in).position(inIndex - in.arrayOffset());
+                        ((Buffer)out).position(outIndex - out.arrayOffset());
                         return CoderResult.malformedForLength(1);
                     }
                     // First byte EE..EF, second byte 80..BF
                     if (jchar > 0x6D && jchar < 0x70 &&
                             (bArr[inIndex + 1] & 0xC0) != 0x80) {
-                        in.position(inIndex - in.arrayOffset());
-                        out.position(outIndex - out.arrayOffset());
+                        ((Buffer)in).position(inIndex - in.arrayOffset());
+                        ((Buffer)out).position(outIndex - out.arrayOffset());
                         return CoderResult.malformedForLength(1);
                     }
                     // First byte F0, second byte 90..BF
                     if (jchar == 0x70 &&
                             ((bArr[inIndex + 1] & 0xFF) < 0x90 ||
                             (bArr[inIndex + 1] & 0xFF) > 0xBF)) {
-                        in.position(inIndex - in.arrayOffset());
-                        out.position(outIndex - out.arrayOffset());
+                        ((Buffer)in).position(inIndex - in.arrayOffset());
+                        ((Buffer)out).position(outIndex - out.arrayOffset());
                         return CoderResult.malformedForLength(1);
                     }
                     // First byte F1..F3, second byte 80..BF
                     if (jchar > 0x70 && jchar < 0x74 &&
                             (bArr[inIndex + 1] & 0xC0) != 0x80) {
-                        in.position(inIndex - in.arrayOffset());
-                        out.position(outIndex - out.arrayOffset());
+                        ((Buffer)in).position(inIndex - in.arrayOffset());
+                        ((Buffer)out).position(outIndex - out.arrayOffset());
                         return CoderResult.malformedForLength(1);
                     }
                     // First byte F4, second byte 80..8F
                     if (jchar == 0x74 &&
                             (bArr[inIndex + 1] & 0xF0) != 0x80) {
-                        in.position(inIndex - in.arrayOffset());
-                        out.position(outIndex - out.arrayOffset());
+                        ((Buffer)in).position(inIndex - in.arrayOffset());
+                        ((Buffer)out).position(outIndex - out.arrayOffset());
                         return CoderResult.malformedForLength(1);
                     }
                 }
                 // Check third byte if present and expected
                 if (tailAvailable > 1 && tail > 1) {
                     if ((bArr[inIndex + 2] & 0xC0) != 0x80) {
-                        in.position(inIndex - in.arrayOffset());
-                        out.position(outIndex - out.arrayOffset());
+                        ((Buffer)in).position(inIndex - in.arrayOffset());
+                        ((Buffer)out).position(outIndex - out.arrayOffset());
                         return CoderResult.malformedForLength(2);
                     }
                 }
                 // Check fourth byte if present and expected
                 if (tailAvailable > 2 && tail > 2) {
                     if ((bArr[inIndex + 3] & 0xC0) != 0x80) {
-                        in.position(inIndex - in.arrayOffset());
-                        out.position(outIndex - out.arrayOffset());
+                        ((Buffer)in).position(inIndex - in.arrayOffset());
+                        ((Buffer)out).position(outIndex - out.arrayOffset());
                         return CoderResult.malformedForLength(3);
                     }
                 }
@@ -250,8 +251,8 @@ public class Utf8Decoder extends Charset
                 for (int i = 0; i < tail; i++) {
                     int nextByte = bArr[inIndex + i + 1] & 0xFF;
                     if ((nextByte & 0xC0) != 0x80) {
-                        in.position(inIndex - in.arrayOffset());
-                        out.position(outIndex - out.arrayOffset());
+                        ((Buffer)in).position(inIndex - in.arrayOffset());
+                        ((Buffer)out).position(outIndex - out.arrayOffset());
                         return CoderResult.malformedForLength(1 + i);
                     }
                     jchar = (jchar << 6) + nextByte;
@@ -259,8 +260,8 @@ public class Utf8Decoder extends Charset
                 jchar -= remainingNumbers[tail];
                 if (jchar < lowerEncodingLimit[tail]) {
                     // Should have been encoded in fewer octets
-                    in.position(inIndex - in.arrayOffset());
-                    out.position(outIndex - out.arrayOffset());
+                    ((Buffer)in).position(inIndex - in.arrayOffset());
+                    ((Buffer)out).position(outIndex - out.arrayOffset());
                     return CoderResult.malformedForLength(1);
                 }
                 inIndex += tail;
@@ -281,8 +282,8 @@ public class Utf8Decoder extends Charset
                     // Encoded with 4 bytes. inIndex currently points
                     // to the final byte. Move it back to first byte.
                     inIndex -= 3;
-                    in.position(inIndex - in.arrayOffset());
-                    out.position(outIndex - out.arrayOffset());
+                    ((Buffer)in).position(inIndex - in.arrayOffset());
+                    ((Buffer)out).position(outIndex - out.arrayOffset());
                     return CoderResult.OVERFLOW;
                 }
                 cArr[outIndex++] = (char) ((jchar >> 0xA) + 0xD7C0);
@@ -290,8 +291,8 @@ public class Utf8Decoder extends Charset
                 outRemaining -= 2;
             }
         }
-        in.position(inIndex - in.arrayOffset());
-        out.position(outIndex - out.arrayOffset());
+        ((Buffer)in).position(inIndex - in.arrayOffset());
+        ((Buffer)out).position(outIndex - out.arrayOffset());
         return (outRemaining == 0 && inIndex < inIndexLimit) ?
                 CoderResult.OVERFLOW :
                 CoderResult.UNDERFLOW;
Index: apache-tomcat-9.0.33-src/java/org/apache/tomcat/util/buf/Utf8Encoder.java
===================================================================
--- apache-tomcat-9.0.33-src.orig/java/org/apache/tomcat/util/buf/Utf8Encoder.java
+++ apache-tomcat-9.0.33-src/java/org/apache/tomcat/util/buf/Utf8Encoder.java
@@ -16,6 +16,7 @@
  */
 package org.apache.tomcat.util.buf;
 
+import java.nio.Buffer;
 import java.nio.ByteBuffer;
 import java.nio.CharBuffer;
 import java.nio.charset.CharsetEncoder;
@@ -56,8 +57,8 @@ public class Utf8Encoder extends Charset
 
             if (jchar <= 0x7F) {
                 if (outRemaining < 1) {
-                    in.position(x);
-                    out.position(outPos);
+                    ((Buffer)in).position(x);
+                    ((Buffer)out).position(outPos);
                     return CoderResult.OVERFLOW;
                 }
                 bArr[outPos++] = (byte) (jchar & 0xFF);
@@ -65,8 +66,8 @@ public class Utf8Encoder extends Charset
             } else if (jchar <= 0x7FF) {
 
                 if (outRemaining < 2) {
-                    in.position(x);
-                    out.position(outPos);
+                    ((Buffer)in).position(x);
+                    ((Buffer)out).position(outPos);
                     return CoderResult.OVERFLOW;
                 }
                 bArr[outPos++] = (byte) (0xC0 + ((jchar >> 6) & 0x1F));
@@ -77,21 +78,21 @@ public class Utf8Encoder extends Charset
 
                 // in has to have one byte more.
                 if (limit <= x + 1) {
-                    in.position(x);
-                    out.position(outPos);
+                    ((Buffer)in).position(x);
+                    ((Buffer)out).position(outPos);
                     return CoderResult.UNDERFLOW;
                 }
 
                 if (outRemaining < 4) {
-                    in.position(x);
-                    out.position(outPos);
+                    ((Buffer)in).position(x);
+                    ((Buffer)out).position(outPos);
                     return CoderResult.OVERFLOW;
                 }
 
                 // The surrogate pair starts with a low-surrogate.
                 if (jchar >= 0xDC00) {
-                    in.position(x);
-                    out.position(outPos);
+                    ((Buffer)in).position(x);
+                    ((Buffer)out).position(outPos);
                     return CoderResult.malformedForLength(1);
                 }
 
@@ -99,8 +100,8 @@ public class Utf8Encoder extends Charset
 
                 // The surrogate pair ends with a high-surrogate.
                 if (jchar2 < 0xDC00) {
-                    in.position(x);
-                    out.position(outPos);
+                    ((Buffer)in).position(x);
+                    ((Buffer)out).position(outPos);
                     return CoderResult.malformedForLength(1);
                 }
 
@@ -121,8 +122,8 @@ public class Utf8Encoder extends Charset
             } else {
 
                 if (outRemaining < 3) {
-                    in.position(x);
-                    out.position(outPos);
+                    ((Buffer)in).position(x);
+                    ((Buffer)out).position(outPos);
                     return CoderResult.OVERFLOW;
                 }
                 bArr[outPos++] = (byte) (0xE0 + ((jchar >> 12) & 0x0F));
@@ -131,8 +132,8 @@ public class Utf8Encoder extends Charset
                 outRemaining -= 3;
             }
             if (outRemaining == 0) {
-                in.position(x + 1);
-                out.position(outPos);
+                ((Buffer)in).position(x + 1);
+                ((Buffer)out).position(outPos);
                 // If both input and output are exhausted, return UNDERFLOW
                 if (x + 1 == limit) {
                     return CoderResult.UNDERFLOW;
@@ -143,8 +144,8 @@ public class Utf8Encoder extends Charset
 
         }
         if (rem != 0) {
-            in.position(x);
-            out.position(outPos);
+            ((Buffer)in).position(x);
+            ((Buffer)out).position(outPos);
         }
         return CoderResult.UNDERFLOW;
     }
@@ -228,7 +229,7 @@ public class Utf8Encoder extends Charset
                 pos++;
             }
         } finally {
-            in.position(pos);
+            ((Buffer)in).position(pos);
         }
         return CoderResult.UNDERFLOW;
     }
Index: apache-tomcat-9.0.33-src/java/org/apache/tomcat/util/net/AprEndpoint.java
===================================================================
--- apache-tomcat-9.0.33-src.orig/java/org/apache/tomcat/util/net/AprEndpoint.java
+++ apache-tomcat-9.0.33-src/java/org/apache/tomcat/util/net/AprEndpoint.java
@@ -20,6 +20,7 @@ import java.io.EOFException;
 import java.io.IOException;
 import java.net.InetSocketAddress;
 import java.net.SocketTimeoutException;
+import java.nio.Buffer;
 import java.nio.ByteBuffer;
 import java.nio.channels.CompletionHandler;
 import java.nio.charset.StandardCharsets;
@@ -2040,7 +2041,7 @@ public class AprEndpoint extends Abstrac
             //      SSL and app buffer size settings with NIO & NIO2.
             if (endpoint.isSSLEnabled()) {
                 sslOutputBuffer = ByteBuffer.allocateDirect(SSL_OUTPUT_BUFFER_SIZE);
-                sslOutputBuffer.position(SSL_OUTPUT_BUFFER_SIZE);
+                ((Buffer)sslOutputBuffer).position(SSL_OUTPUT_BUFFER_SIZE);
             } else {
                 sslOutputBuffer = null;
             }
@@ -2102,7 +2103,7 @@ public class AprEndpoint extends Abstrac
             // The socket read buffer capacity is socket.appReadBufSize
             int limit = socketBufferHandler.getReadBuffer().capacity();
             if (to.isDirect() && to.remaining() >= limit) {
-                to.limit(to.position() + limit);
+                ((Buffer)to).limit(to.position() + limit);
                 nRead = fillReadBuffer(block, to);
                 if (log.isDebugEnabled()) {
                     log.debug("Socket: [" + this + "], Read direct from socket: [" + nRead + "]");
@@ -2181,7 +2182,7 @@ public class AprEndpoint extends Abstrac
             }
 
             if (result > 0) {
-                to.position(to.position() + result);
+                ((Buffer)to).position(to.position() + result);
                 return result;
             } else if (result == 0 || -result == Status.EAGAIN) {
                 return 0;
@@ -2303,9 +2304,9 @@ public class AprEndpoint extends Abstrac
                 if (getEndpoint().isSSLEnabled()) {
                     if (sslOutputBuffer.remaining() == 0) {
                         // Buffer was fully written last time around
-                        sslOutputBuffer.clear();
+                        ((Buffer)sslOutputBuffer).clear();
                         transfer(from, sslOutputBuffer);
-                        sslOutputBuffer.flip();
+                        ((Buffer)sslOutputBuffer).flip();
                     } else {
                         // Buffer still has data from previous attempt to write
                         // APR + SSL requires that exactly the same parameters are
@@ -2314,13 +2315,13 @@ public class AprEndpoint extends Abstrac
                     thisTime = Socket.sendb(getSocket().longValue(), sslOutputBuffer,
                             sslOutputBuffer.position(), sslOutputBuffer.limit());
                     if (thisTime > 0) {
-                        sslOutputBuffer.position(sslOutputBuffer.position() + thisTime);
+                        ((Buffer)sslOutputBuffer).position(sslOutputBuffer.position() + thisTime);
                     }
                 } else {
                     thisTime = Socket.sendb(getSocket().longValue(), from, from.position(),
                             from.remaining());
                     if (thisTime > 0) {
-                        from.position(from.position() + thisTime);
+                        ((Buffer)from).position(from.position() + thisTime);
                     }
                 }
                 if (Status.APR_STATUS_IS_EAGAIN(-thisTime)) {
Index: apache-tomcat-9.0.33-src/java/org/apache/tomcat/util/net/Nio2Endpoint.java
===================================================================
--- apache-tomcat-9.0.33-src.orig/java/org/apache/tomcat/util/net/Nio2Endpoint.java
+++ apache-tomcat-9.0.33-src/java/org/apache/tomcat/util/net/Nio2Endpoint.java
@@ -22,6 +22,7 @@ import java.io.IOException;
 import java.net.InetSocketAddress;
 import java.net.SocketAddress;
 import java.net.SocketTimeoutException;
+import java.nio.Buffer;
 import java.nio.ByteBuffer;
 import java.nio.channels.AsynchronousChannelGroup;
 import java.nio.channels.AsynchronousCloseException;
@@ -541,7 +542,7 @@ public class Nio2Endpoint extends Abstra
                         if (nRead > 0) {
                             getSocket().getBufHandler().configureWriteBufferForRead();
                             if (attachment.length < buffer.remaining()) {
-                                buffer.limit(buffer.limit() - buffer.remaining() + (int) attachment.length);
+                                ((Buffer)buffer).limit(buffer.limit() - buffer.remaining() + (int) attachment.length);
                             }
                             attachment.length -= nRead;
                         } else {
@@ -886,7 +887,7 @@ public class Nio2Endpoint extends Abstra
                 // The socket read buffer capacity is socket.appReadBufSize
                 int limit = socketBufferHandler.getReadBuffer().capacity();
                 if (block && to.remaining() >= limit) {
-                    to.limit(to.position() + limit);
+                    ((Buffer)to).limit(to.position() + limit);
                     nRead = fillReadBuffer(block, to);
                     if (log.isDebugEnabled()) {
                         log.debug("Socket: [" + this + "], Read direct from socket: [" + nRead + "]");
Index: apache-tomcat-9.0.33-src/java/org/apache/tomcat/util/net/NioEndpoint.java
===================================================================
--- apache-tomcat-9.0.33-src.orig/java/org/apache/tomcat/util/net/NioEndpoint.java
+++ apache-tomcat-9.0.33-src/java/org/apache/tomcat/util/net/NioEndpoint.java
@@ -23,6 +23,7 @@ import java.io.IOException;
 import java.net.InetAddress;
 import java.net.InetSocketAddress;
 import java.net.SocketTimeoutException;
+import java.nio.Buffer;
 import java.nio.ByteBuffer;
 import java.nio.channels.CancelledKeyException;
 import java.nio.channels.Channel;
@@ -1137,7 +1138,7 @@ public class NioEndpoint extends Abstrac
             // The socket read buffer capacity is socket.appReadBufSize
             int limit = socketBufferHandler.getReadBuffer().capacity();
             if (to.remaining() >= limit) {
-                to.limit(to.position() + limit);
+                ((Buffer)to).limit(to.position() + limit);
                 nRead = fillReadBuffer(block, to);
                 if (log.isDebugEnabled()) {
                     log.debug("Socket: [" + this + "], Read direct from socket: [" + nRead + "]");
